



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>UVA 11610 Reverse Prime (数论+树状数组+二分，难题)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">UVA 11610 Reverse Prime (数论+树状数组+二分，难题)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:34:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>参考链接<br /><a href="http://blog.csdn.net/acm_cxlove/article/details/8264290" rel="external nofollow noreferrer">http://blog.csdn.net/acm_cxlove/article/details/8264290</a><br /><a href="http://blog.csdn.net/w00w12l/article/details/8212782" rel="external nofollow noreferrer">http://blog.csdn.net/w00w12l/article/details/8212782</a></p>
<p>题意：<br />    　　首先定义了一种叫做Reverse Prime的数：是一个7位数，倒置后是一个&lt;=10^6的素数（如1000070）<br />    　　然后要把所有的Reverse Prime求出来，排好序。<br />    　　然后题目有2种操作：<br />    　　q x ：求编号0到编号x的Reverse Prime的质因数个数的和<br />    　　d x ：从表中删掉x（x是一个Reverse Prime）</p>
<p>思路：<br />    　　1.先按照题目要求筛选素数，同时求出每个数的只因数个数，再将小于10^6的素数倒置，转化成Reverse Prime，排序离散化<br />    　　2.建立两个树状数组，cnt存储区间内的个数，num存储区间内的质因数个数和。<br />    　　3.当执行q x 操作时，二分查找最小的mid值，使得sumcnt(mid)=++x（因为x是从0开始的，所以要+1），然后对num树状数组的1~mid区间求和<br />    　　4.当执行d x 操作时，可以用二分查找或者map映射获取x的下标，然后对两个树状数组进行更新即可。</p>
<p>　　最后要注意的是，由于Reverse Prime是由10^6以下的素数倒置得到的，那么得到的要求是7位，最后一位一定是0，<br />    　　我们可以对每个除以10处理。即不考虑末尾的0，最后求质因数个数的时候记得加上2（最后末尾0的因子2和5）。</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;stdio.h&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;map&gt;

using namespace std;<br />
const int maxn=;<br />
int isprime[maxn];  //标记素数<br />
int factor[maxn];  //factor[i]存储i的质因数个数<br />
int prime[maxn];  //存储素数<br />
int idx;  //prime数组的下标<br />
long long cnt[maxn];  //统计区间内reverse prime number的个数<br />
long long num[maxn]; //统计区间内reverse prime number的质因数的个数<br />
map&lt;int,int&gt; m;

struct RPrimeNum{<br />
    int num;<br />
    int factor;  //存储质因数的个数<br />
    bool operator&lt;(const RPrimeNum tmp)const{<br />
        return num&lt;tmp.num;<br />
    }<br />
}reverse_prime_num[maxn];<br />
int ridx;  //reverse_prime_num数组的下标

int lowbit(int x){<br />
    return x&amp;(-x);<br />
}<br />
//对数组cnt的更新操作<br />
void updatecnt(int i,int v){<br />
    while(i&lt;=ridx){<br />
        cnt[i]+=v;<br />
        i+=lowbit(i);<br />
    }<br />
}<br />
//对数组cnt的求和操作<br />
long long sumcnt(int i){<br />
    long long res=;<br />
    while(i){<br />
        res+=cnt[i];<br />
        i-=lowbit(i);<br />
    }<br />
    return res;<br />
}<br />
//对数组num的更新操作<br />
void updatenum(int i,int v){<br />
    while(i&lt;=ridx){<br />
        num[i]+=v;<br />
        i+=lowbit(i);<br />
    }<br />
}<br />
//对数组num的求和操作<br />
long long sumnum(int i){<br />
    long long res=;<br />
    while(i){<br />
        res+=num[i];<br />
        i-=lowbit(i);<br />
    }<br />
    return res;<br />
}

void init(){<br />
    memset(isprime,,sizeof(isprime));<br />
    memset(factor,,sizeof(factor));<br />
    idx=-;<br />
    //利用素数筛选法求质因数的个数<br />
    //因为所有素数都是6位数，但是题目要求是7位数，可见原数的最低位都为0，可以先不考虑这个0，因此maxn的值为1000001<br />
    for(int i=;i&lt;maxn;i++){<br />
        if(!isprime[i]){<br />
            prime[++idx]=i;<br />
            for(int j=i*;j&lt;maxn;j+=i){<br />
                isprime[j]=i;   //记录它被哪个数所筛<br />
            }<br />
        }<br />
    }<br />
    //求一个数的质因数个数<br />
    for(int i=;i&lt;maxn;i++){<br />
        if(!isprime[i])<br />
            factor[i]=;<br />
        else<br />
            factor[i]=factor[i/isprime[i]]+;   //1 即为prime[i]<br />
    }<br />
    ridx=;<br />
    int n,rnum;<br />
    for(int i=;i&lt;=idx;i++){<br />
        n=prime[i];<br />
        rnum=;<br />
        while(n){<br />
            rnum=rnum*+n%;<br />
            n=n/;<br />
        }<br />
        while(rnum&lt;){<br />
            rnum*=;<br />
        }<br />
        reverse_prime_num[++ridx].num=rnum*;<br />
        reverse_prime_num[ridx].factor=factor[rnum]+;  //2：最后一位没考虑的0，即2和5两个质因子<br />
    }<br />
    sort(reverse_prime_num+,reverse_prime_num+ridx+);  //额，前面第一个应该+1的，一不小心给漏了

    for(int i=;i&lt;=ridx;i++)<br />
        m[reverse_prime_num[i].num/]=i;  //map映射

    memset(num,,sizeof(num));<br />
    memset(cnt,,sizeof(cnt));<br />
    for(int i=;i&lt;=ridx;i++){<br />
        updatenum(i,reverse_prime_num[i].factor);<br />
        cnt[i]=lowbit(i); //因为更新的值为1，所以只要直接赋值lowbit(i)即可<br />
    }<br />
}<br />
//二分搜索第m个reverse prime对应的下标<br />
int binarySearch1(int m){<br />
    int l=,r=ridx,mid;<br />
    long long ans;<br />
    while(r&gt;=l){<br />
        mid=(l+r)&gt;&gt;;<br />
        ans=sumcnt(mid);<br />
        if(ans==m)<br />
            return mid;<br />
        if(m&lt;ans)<br />
            r=mid-;<br />
        else<br />
            l=mid+;<br />
    }<br />
}<br />
//也可以通过二分搜索reverse prime对应的下标<br />
int binarySearch2(int m){<br />
    int l=,r=ridx,mid;<br />
    while(r&gt;=l){<br />
        mid=(l+r)&gt;&gt;;<br />
        if(m==reverse_prime_num[mid].num)<br />
            return mid;<br />
        if(m&lt;reverse_prime_num[mid].num)<br />
            r=mid-;<br />
        else<br />
            l=mid+;<br />
    }<br />
}<br />
int main()<br />
{<br />
    char str[];<br />
    int v;<br />
    init();<br />
    while(scanf("%s%d",str,&amp;v)!=EOF){<br />
        if(str[]=='q'){<br />
            v++;<br />
            int u=binarySearch1(v);<br />
            printf("%lld\n",sumnum(u));<br />
        }<br />
        else{<br />
            //int u=binarySearch2(v);  //二分超找对应的下标<br />
            int u=m[v/];  //通过建立map映射获取下标<br />
            updatecnt(u,-);<br />
            updatenum(u,-reverse_prime_num[u].factor);<br />
        }<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxnv208.html">Linux学习&lpar;CentOS-7&rpar;---磁盘分区（概念、分区方法、分区方案）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93741g8.html">关于readdir返回值中struct dirent&period;d&lowbar;type的取值有关问题（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r6vdd9.html">Homebrew简介及安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932x3nq.html">mysql局域网连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke4058.html">Java核心知识点学习----多线程中的阻塞队列&comma;ArrayBlockingQueue介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mxpd1q.html">C＃中获取程序集版本号的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd7ple8.html">DbHelper数据操作类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmp7409.html">memcached 学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xenxz9.html">51单片机实现对24C02进行页写、顺序读取并显示验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wo0pxq.html">Arcgis api For silverlight 加载高德地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6glxq.html">【Android病毒分析报告】 - ZooTiger &OpenCurlyDoubleQuote;集恶意推广、隐私窃取、恶意吸费于一体&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pd5x48.html">Nginx 反向代理、负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25d0z3q.html">python学习记录-机器学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjz4eq.html">Codeforces Codeforces Round &num;484 &lpar;Div&period; 2&rpar; E&period; Billiard</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv00gy8.html">oracle　 的sqlplus 工具进行翻译的rlwrap 安装教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy52w2q.html">Linux基础操作整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wkep0q.html">【 HDU - 4456 】Crowd &lpar;二维树状数组、cdq分治&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gv53mq.html">使用SqlSugar 4&period;X的T4生成实体类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eerkg9.html">JAVA构造方法与方法是啥意思，方法重载方法覆盖俗谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvem6k19.html">word 2007 写CSDN博客</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvveo0xq.html">Node&period;js学习笔记 02 Implementing flow control</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v2nk48.html">java的基本数据类型特征</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wke3oq.html">eclipse导出Runnable Jar File在Launch Configuration中找不到类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydv31jq.html">DeviceOne开发HelloWord</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjp5pk9.html">Android--简单开发和使用ContentProvider数据共享</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1k0kd9.html">typings的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvexnyq.html">C&num;开源大全--汇总（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ypx0eq.html">ELK kibana查询与过滤&lpar;17th&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdl66l8.html">学习笔记--HashMap浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mepwxq.html">UIKit&amp;&num;160&semi;框架之UISearchController</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
